
import time, data, math, random, pixelperfect, os, sys


import pygame
import main
from pygame.locals import *
from pixelperfect import *

class Sbackground(pygame.sprite.Sprite):

    def __init__(self):

        pygame.sprite.Sprite.__init__(self, self.containers)
        self.images = [data.load_image("grid.png"), data.load_image("grid.png"), data.load_image("grid.png"), data.load_image("grid.png")]
        self.imagenumb = random.choice([0,1,2,3])
        self.image = self.images[self.imagenumb]
        self.rect = self.image.get_rect(midright = (874, 384))

    def update(self):
        screenrect = Rect(0, 800, 1024, 100)

class Letters(pygame.sprite.Sprite):

    def __init__(self):

        pygame.sprite.Sprite.__init__(self, self.containers)
        self.images = [data.load_image("w.png"), data.load_image("a.png"), data.load_image("s.png"), data.load_image("d.png")]
        self.imagenumb = random.choice([0,1,2,3])
        self.image = self.images[self.imagenumb]
        self.rect = self.image.get_rect(midright = (365, 0))
        self.speed = 2

    def update(self):
        screenrect = Rect(0, 800, 1024, 100)
        self.rect.move_ip(0, self.speed)
        if screenrect.contains(self.rect):
            self.kill()
            
class Arrows(pygame.sprite.Sprite):

    def __init__(self):

        pygame.sprite.Sprite.__init__(self, self.containers)
        self.images = [data.load_image("uparrow.png"), data.load_image("downarrow.png"), data.load_image("leftarrow.png"), data.load_image("rightarrow.png")]
        self.imagenumb = random.choice([0,1,2,3])
        self.image = self.images[self.imagenumb]
        self.rect = self.image.get_rect(midright = (700, 800))
        self.speed = 3

    def update(self):
        screenrect = Rect(0, -100, 1024, 100)
        self.rect.move_ip(0, -self.speed)
        if screenrect.contains(self.rect):
            self.kill()


class LHitbox(pygame.sprite.Sprite):

    def __init__(self):

        pygame.sprite.Sprite.__init__(self, self.containers)
        self.image = data.load_image("hitbox.png")
        self.rect = self.image.get_rect(center = (340, 400))
        
class RHitbox(pygame.sprite.Sprite):

    def __init__(self):

        pygame.sprite.Sprite.__init__(self, self.containers)
        self.image = data.load_image("hitbox.png")
        self.rect = self.image.get_rect(center = (675, 400))
        

def game(screen):

    all = pygame.sprite.OrderedUpdates()
    pygame.mixer.music.load("data\/7.mid")
    pygame.mixer.music.play(0)
    menu = main.MainMenu()
    
    lhitbox = pygame.sprite.Group()
    rhitbox = pygame.sprite.Group()
    letters = pygame.sprite.Group()
    arrows = pygame.sprite.Group()
    sbackground = pygame.sprite.Group()
    mtimer = 140
    

    score=0
    
    LHitbox.containers = all, lhitbox
    RHitbox.containers = all, rhitbox
    Letters.containers = all, letters
    Arrows.containers = all, arrows
    Sbackground.containers = all, sbackground
    

    clock = pygame.time.Clock()
    background = data.load_image("background.png")
    keysLegend = data.load_image("keys_legend.png")
    arrowsLegend = data.load_image("arrows_legend.png")
    font = pygame.font.Font(data.filepath("Vera.ttf"), 16)
    font2 = pygame.font.Font(data.filepath("Vera.ttf"), 32)
    font3 = pygame.font.Font(data.filepath("Vera.ttf"), 60)
    Letters()
    LHitbox()
    RHitbox()
    Arrows()
    Sbackground()
    lprintgood = 0
    lprintbad = 0
    aprintgood = 0
    aprintbad = 0
    kpressed = ""
    lcanclick = 0
    rcanclick = 0
    lelapsed_time = 0
    relapsed_time = 0
    mcounter = 0
    endscore = pygame.Surface((1024,768))
    begin = pygame.Surface((1024,768))
    endscore.fill((0,0,0))
    begin.fill((0,0,0))
    begin.blit(font3.render("BONUS LEVEL", True, (255,0,0)), (425,320))
    screen.blit(begin, (0,0))
    pygame.display.update()
    time.sleep(3)
    edown = False


    lstart_time = time.time()
    rstart_time = time.time()
    while 1:

        clock.tick(60)
        if mtimer == 0:
            return score

        if mcounter == 60:
            mtimer -= 1
            mcounter = 0
        else:
            mcounter += 1
        
        all.update()
        
        for e in pygame.event.get():
            if e.type == QUIT:
                pygame.quit()
                return
            if e.type == KEYDOWN:
                if e.key == K_w:
                    kpressed="w"
                if e.key == K_a:
                    kpressed="a"
                if e.key == K_s:
                    kpressed="s"
                if e.key == K_d:
                    kpressed="d"
                    
                if e.key == K_UP:
                    kpressed = "up"
                if e.key == K_DOWN:
                    kpressed = "down"
                if e.key == K_LEFT:
                    kpressed = "left"
                if e.key == K_RIGHT:
                    kpressed = "right"
            if e.type == pygame.KEYUP:
                if e.key == K_ESCAPE:
                    edown = False

        if pygame.mixer.music.get_busy() == False:
            endscore.blit(font3.render(str(score),True,(255,255,255)),(475, 320))
            screen.blit(endscore, (0,0))
            pygame.display.update()
            time.sleep(5)
            return score
            
        lelapsed_time = round(time.time() - lstart_time, 0)
        relapsed_time = round(time.time() - rstart_time, 0)


        
######################################################################################        
        #CONTROL SPAWN SPEED OF LEFT OR RIGHT SIDE######
######################################################################################     
        if lelapsed_time>1:
            lstart_time = time.time()
            Letters()

            lprintgood=0
            lprintbad=0
            aprintgood=0
            aprintbad=0
            kpressed=""
            lcanclick = 1
            
        if relapsed_time>2:
            rstart_time = time.time()
            Arrows().speed
            kpressed=""
            rcanclick = 1
   

        sbackground.draw(screen)
        
        letters.draw(screen)
        lhitbox.draw(screen)
        arrows.draw(screen)
        rhitbox.draw(screen)
        screen.blit(background, (0, 0))
        
        screen.blit(keysLegend, (40, 600))
        screen.blit(arrowsLegend,(800, 600))
        

        for s in letters.sprites():
            c = spritecollide_pp(s,lhitbox,0)
            if c:
                if kpressed=="w" and lcanclick == 1:
                    if s.imagenumb==0:
                        score+=100
                        lprintgood=1
                        lprintbad=0
                        s.kill()
                        lcanclick=0
                    else:
                        score-=200
                        lprintbad=1
                        lprintgood=0
                        lcanclick=0
                if kpressed=="a" and lcanclick == 1:
                    if s.imagenumb==1:
                        score+=100
                        lprintgood=1
                        lprintbad=0
                        s.kill()
                        lcanclick=0
                    else:
                        score-=200
                        lprintbad=1
                        lprintgood=0
                        lcanclick=0
                if kpressed=="s" and lcanclick == 1:
                    if s.imagenumb==2:
                        score+=100
                        lprintgood=1
                        lprintbad=0
                        s.kill()
                        lcanclick=0
                    else:
                        score-=200
                        lprintbad=1
                        lprintgood=0
                        lcanclick=0
                if kpressed=="d" and lcanclick == 1:
                    if s.imagenumb==3:
                        score+=100
                        lprintgood=1
                        lprintbad=0
                        s.kill()
                        lcanclick=0
                    else:
                        score-=200
                        lprintbad=1
                        lprintgood=0
                        lcanclick=0


############################
        for s in arrows.sprites():
            c = spritecollide_pp(s,rhitbox,0)
            if c:       
                if kpressed=="up" and rcanclick == 1:
                    if s.imagenumb==0:
                        score+=100
                        aprintgood=1
                        aprintbad=0
                        s.kill()
                        rcanclick=0
                    else:
                        score-=200
                        aprintbad=1
                        aprintgood=0
                        rcanclick=0
                if kpressed=="down" and rcanclick == 1:
                    if s.imagenumb==1:
                        score+=100
                        aprintgood=1
                        aprintbad=0
                        s.kill()
                        rcanclick=0
                    else:
                        score-=200
                        aprintbad=1
                        aprintgood=06
                        rcanclick=0
                if kpressed=="left" and rcanclick == 1:
                    if s.imagenumb==2:
                        score+=100
                        aprintgood=1
                        aprintbad=0
                        s.kill()
                        rcanclick=0
                    else:
                        score-=200
                        aprintbad=1
                        aprintgood=0
                        rcanclick=0
                if kpressed=="right" and rcanclick == 1:
                    if s.imagenumb==3:
                        score+=100
                        aprintgood=1
                        aprintbad=0
                        s.kill()
                        rcanclick=0
                    else:
                        score-=200
                        aprintbad=1
                        aprintgood=0
                        rcanclick=0


        if score < 0:
            score = 0
        if lprintbad==1:
            screen.blit(font.render("BAD!", 7, (255, 255, 255)), (200, 350))                            

        if lprintgood==1:
            screen.blit(font.render("GOOD!", 7, (255, 255, 255)), (200, 350))
            
        if aprintbad==1:
            screen.blit(font.render("BAD!", 7, (255, 255, 255)), (600, 350))                            

        if aprintgood==1:
            screen.blit(font.render("GOOD!", 7, (255, 255, 255)), (600, 350))
            
        ren = font.render("Score: %d" % score, 1, (0, 0, 255))
        screen.blit(ren, (15, 300))
                                
        pygame.display.flip()


def Bonus():
    if sys.platform == "win32" or sys.platform == "win64":
        os.environ["SDL_VIDEO_CENTERED"] = "1"

    pygame.init()
    pygame.mixer.init()

    pygame.display.set_caption("MiniGame")
    screen = pygame.display.set_mode((1024, 768))
    pygame.mouse.set_visible(0)
    score = game(screen)
    print score
    pygame.quit()

if __name__ == "__main__":
    Bonus()
