import pygame
import random
import bonus
import time

class Grid(object):
    def __init__(self, x, y):
        self.surface = pygame.image.load("data\/grid.png").convert_alpha()
        self.width = self.surface.get_width()
        self.height = self.surface.get_height()
        self.squareSize = 60
        self.list = []
        self.partsList = []
        self.gridPos = (152, 24)
        self.gridSelection = -1
        self.density = 2
        self.start = 0
        self.end = 0
        self.current = 0
        self.currentList = []
        self.voltage = 0
        self.voltageNeeded = 0
        self.cameFrom = "left"
        self.font = pygame.font.SysFont("Arial", 12)
        self.Load()

    def CheckPower(self):
        self.current = self.start
        # Clear currentList
        self.currentList[:] = []

        # Set all parts.used equal to false
        for p in self.partsList:
            if(p):
                p.used = False

        self.currentList.append(self.start)
        if(self.partsList[self.start + 1]):
            if(self.partsList[self.start + 1].left == True):
                self.current += 1

                done = False
                checkRight = False
                checkLeft = False
                checkUp = False
                checkDown = False
                self.cameFrom = None
                while(done == False):
                    if((checkUp == True and checkDown == True and checkLeft == True and checkRight == True) or self.partsList[self.current].type == "end"):
                        done = True
                        self.currentList.append(self.current)
                    else:
                        if(self.partsList[self.current].right == True and self.cameFrom != "right" and checkRight == False):
                            if(self.current%12 < 11):
                                if(self.partsList[self.current + 1]):
                                    if(self.partsList[self.current + 1].left == True):
                                        self.currentList.append(self.current)
                                        self.current += 1
                                        self.cameFrom = "left"
                                        checkLeft = False
                                        checkRight = False
                                        checkUp = False
                                        checkDown = False
                                    else:
                                        checkRight = True
                                else:
                                    if(self.current - 1 == self.start):
                                        self.cameFrom = "left"
                                    checkRight = True
                            else:
                                checkRight = True
                        elif(self.partsList[self.current].up == True and self.cameFrom != "up" and checkUp == False):
                            if(self.current > 11):
                                if(self.partsList[self.current - 12]):
                                    if(self.partsList[self.current - 12].down == True):
                                        self.currentList.append(self.current)
                                        self.current -= 12
                                        self.cameFrom = "down"
                                        checkLeft = False
                                        checkRight = False
                                        checkUp = False
                                        checkDown = False
                                    else:
                                        checkUp = True
                                else:
                                    checkUp = True
                            else:
                                checkUp = True
                        elif(self.partsList[self.current].down == True and self.cameFrom != "down" and checkDown == False):
                            if(self.current < 132):
                                if(self.partsList[self.current + 12]):
                                    if(self.partsList[self.current + 12].up == True):
                                        self.currentList.append(self.current)
                                        self.current += 12
                                        self.cameFrom = "up"
                                        checkLeft = False
                                        checkRight = False
                                        checkUp = False
                                        checkDown = False
                                    else:
                                        checkDown = True
                                else:
                                    checkDown = True
                            else:
                                checkDown = True
                        elif(self.partsList[self.current].left == True and self.cameFrom != "left" and checkLeft == False):
                            if(self.current%12 > 0):
                                if(self.partsList[self.current - 1]):
                                    if(self.partsList[self.current - 1].right == True):
                                        self.currentList.append(self.current)
                                        self.current -= 1
                                        self.cameFrom = "right"
                                        checkLeft = False
                                        checkRight = False
                                        checkUp = False
                                        checkDown = False
                                    else:
                                        checkLeft = True
                                else:
                                    checkLeft = True
                            else:
                                checkLeft = True
                        else:
                            checkLeft = True
                            checkRight = True
                            checkUp = True
                            checkDown = True

        for c in self.currentList:
            self.partsList[c].used = True
        
        for c in self.currentList:
            if(c == self.currentList[0]):
                self.voltage = self.partsList[c].voltage
            elif(self.partsList[c].type == "end"):
                for j in self.partsList:
                    if(j):
                        if(j.user == False):
                            if(j.used == False):
                                return "blow"
                if(self.partsList[c].voltageNeeded == self.voltage):
                    return "win"
            else:
                self.voltage -= self.partsList[c].resist

        return

    def Load(self):
        # Puts the top left point of every square in a list
        x = y = 0
        while(y < self.height):
            while(x < self.width):
                # Save the points in a list
                self.list.append((x,y))
                x += self.squareSize
            y += self.squareSize
            x = 0

        for pos in self.list:
            self.partsList.append(None)

    def LoadLevel(self, level, volts, parts):
        # Clear partsList
        i = 0
        for pos in self.list:
            self.partsList[i] = None
            i += 1

        # Add the start and end point to the partsList
        self.start = (random.randint(0,len(self.partsList))/12) * 12
        if(self.start == 144):
            self.start = 132
        self.end = random.randint(0,len(self.partsList))/12 * 12 - 1
        if(self.end == 143):
            self.end -= 12
        StempPart = Part("start")
        EtempPart = Part("end")
        StempPart.user = False
        StempPart.voltage = volts[0]
        EtempPart.user = False
        EtempPart.voltageNeeded = volts[1]
        self.voltageNeeded = volts[1]
        self.partsList[self.start] = StempPart
        self.partsList[self.end] = EtempPart

        # Add random parts to the partsList
        i = 0
        while(i < level * self.density):
            new = random.randint(0,len(parts) - 3)
            pos1 = random.randint(0,len(self.partsList) - 12)/12 * 12
            pos2 = random.randint(2,9)
            tempPart = Part(parts[new].type)
            tempPart.user = False
            tempPart.used = False
            if(self.partsList[pos1 + pos2] == None):
                self.partsList[pos1 + pos2] = tempPart
                i += 1
            

    def Render(self, surface):
        surface.blit(self.surface, self.gridPos)
        i = 0
        for part in self.partsList:
            if(part):
                surface.blit(part.image, (self.list[i][0] + self.gridPos[0], \
                                                                  self.list[i][1] + self.gridPos[1]))
            i += 1

        i = 0
        for pos in self.currentList:
            pygame.draw.rect(surface, (240,240,0), (self.list[pos][0] + self.gridPos[0], self.list[pos][1] + self.gridPos[1], 60, 60), 1)
            if(i == len(self.currentList) - 1):
                surface.blit(self.font.render(str(str(self.voltage) + "v"), True, (240,240,0)), (self.list[pos][0] + self.gridPos[0] + 23, \
                                                                                  self.list[pos][1] + self.gridPos[1]))
            i += 1
            
        if self.gridSelection >= 0:
            pygame.draw.rect(surface, (255,0,0), (self.list[self.gridSelection][0] + self.gridPos[0],\
                                                      self.list[self.gridSelection][1] + self.gridPos[1], 60, 60), 1)
        

class PartsMenu(object):
    def __init__(self):
        self.partsPos = (872, 146)
        self.partsList = []
        self.partsListPos = []
        self.partSelected = 0
        self.Load()
        
    def Load(self):
        self.partsList.append(Part("resist1"))
        self.partsList.append(Part("resist2"))
        self.partsList.append(Part("resist3"))
        self.partsList.append(Part("cap1"))
        self.partsList.append(Part("cap2"))
        self.partsList.append(Part("cap3"))
        self.partsList.append(Part("chip1"))
        self.partsList.append(Part("chip2"))
        self.partsList.append(Part("chip3"))
        self.partsList.append(Part("wire1"))
        self.partsList.append(Part("wire2"))
        
        i = 0
        count = 0
        for part in self.partsList:
            if(count == 0):
                self.partsListPos.append((self.partsPos[0] + 11, self.partsPos[1] + i))
                count += 1
            elif(count == 1):
                self.partsListPos.append((self.partsPos[0] + 81, self.partsPos[1] + i))
                count = 0
                i += 70

    def Render(self, surface):
        i = 0
        for part in self.partsList:
            surface.blit(part.image, (self.partsListPos[i][0], self.partsListPos[i][1]))
                
            if(i == self.partSelected):
                pygame.draw.rect(surface, (0,0,255), (self.partsListPos[i][0], \
                                                        self.partsListPos[i][1], \
                                                        60, 60), 1)
            i += 1

class Part(object):
    def __init__(self, _type):
        self.left = True
        self.right = True
        self.up = False
        self.down = False
        self.type = _type
        self.image = None
        self.voltage = 0
        self.voltageNeeded = 0
        self.resist = 0
        self.user = True
        self.used = False
        self.Load()

    def Load(self):
        self.image = pygame.image.load("data\/" + self.type + ".png").convert_alpha()
        if(self.type == "start"):
            self.left = False
        elif(self.type == "end"):
            self.right = False
        elif(self.type == "wire2"):
            self.up = True
            self.right = False
        elif(self.type == "cap1"):
            self.resist = -5
        elif(self.type == "cap2"):
            self.resist = -15
        elif(self.type == "cap3"):
            self.resist = -30
        elif(self.type == "resist1"):
            self.resist = 5
        elif(self.type == "resist2"):
            self.resist = 15
        elif(self.type == "resist3"):
            self.resist = 30
        elif(self.type == "chip1"):
            self.resist = 10
        elif(self.type == "chip2"):
            self.resist = 20
        elif(self.type == "chip3"):
            self.resist = 50


    def Rotate(self, direction):
        left = self.left
        right = self.right
        up = self.up
        down = self.down
        if(direction == "left"):
            self.image = pygame.transform.rotate(self.image, 90)
            if(up == True):
                self.left = True
            else:
                self.left = False
            if(left == True):
                self.down = True
            else:
                self.down = False
            if(down == True):
                self.right = True
            else:
                self.right = False
            if(right == True):
                self.up = True
            else:
                self.up = False
        else:
            self.image = pygame.transform.rotate(self.image, -90)
            if(up == True):
                self.right = True
            else:
                self.right = False
            if(right == True):
                self.down = True
            else:
                self.down = False
            if(down == True):
                self.left = True
            else:
                self.left = False
            if(left == True):
                self.up = True
            else:
                self.up = False

class MainMenu(object):
    def __init__(self):
        self.clock = pygame.time.Clock()
        self.playing = False
        self.mouse = pygame.image.load("data\/mouse.png").convert_alpha()
        pass
    def runStartMenu(self, Screen):
            menu=pygame.image.load("data\/start1.png").convert_alpha()
            background=pygame.image.load("data\/title.png").convert_alpha()
            start=pygame.image.load("data\/StartStart.png").convert_alpha()
            directions=pygame.image.load("data\/StartDirections.png").convert_alpha()
            mquit=pygame.image.load("data\/StartQuit.png").convert_alpha()
            angle =90
            newmenu=menu
            if(self.playing == False):
                pygame.mixer.music.load("data\/3.mid")
                pygame.mixer.music.play(-1)
                self.playing = True
            while angle >=0:                
                self.clock.tick(60)
                Screen.blit(background,(0,0))
                newmenu=pygame.transform.rotate(menu,angle)
                Screen.blit(newmenu,(97-newmenu.get_width()/2,57-newmenu.get_height()/2))
                pygame.display.update()
                angle-=3
            go=True
            item=start
            
            while go:
                    self.clock.tick(60)
                    Screen.blit(background,(0,0))
                    

                    Screen.blit(item,(97,57))
                    Screen.blit(self.mouse, pygame.mouse.get_pos())
                    pygame.display.update()
                    # Handle key pressed events
                    events = pygame.event.pump()
                    keys = pygame.key.get_pressed()
                    mousePos = pygame.mouse.get_pos()
                    mousePressed = pygame.mouse.get_pressed()
                    
                    if mousePos[0]>=410 and mousePos[0] <= 659:
                        
                        if mousePos[1]>=241 and mousePos[1]<=298:
                            item=start
                            if mousePressed[0]:
                                Screen.blit(background,(0,0))
                                
                                Screen.blit(item,(97,57))
                                Screen.blit(self.mouse, pygame.mouse.get_pos())
                                pygame.display.update()
                                return False
                        elif mousePos[1]>=298 and mousePos[1]<=357:
                            item=directions
                            if mousePressed[0]:
                                Screen.blit(background,(0,0))
                                Screen.blit(item,(97,57))
                                
                                pygame.display.update()
                                Screen.blit(background,(0,0))
                        
                                angle =0
                                newmenu=menu
                                while angle <=90:                
                                    self.clock.tick(60)
                                    Screen.blit(background,(0,0))
                                    newmenu=pygame.transform.rotate(menu,angle)
                                    Screen.blit(newmenu,(97-newmenu.get_width()/2,57-newmenu.get_height()/2))
                                    Screen.blit(self.mouse, pygame.mouse.get_pos())
                                    pygame.display.update()
                                    angle+=3
                                return self.runDirectionsMenu(Screen,"start")
                                
                                
                        
                        elif mousePos[1]>=357 and mousePos[1]<=414:
                            item=mquit
                            if mousePressed[0]:
                                Screen.blit(background,(0,0))
                                Screen.blit(item,(97,57))
                                Screen.blit(self.mouse, pygame.mouse.get_pos())
                                pygame.display.update()
                                Screen.blit(background,(0,0))
                                return True
                            
    def runDirectionsMenu(self, Screen, func):
            menu=pygame.image.load("data\/directions1.png").convert_alpha()
            background=pygame.image.load("data\/title.png").convert_alpha()
            back = pygame.image.load("data\/directions2.png").convert_alpha()
            angle =90
            newmenu=menu
            while angle >=0:                
                self.clock.tick(60)
                Screen.blit(background,(0,0))
                newmenu=pygame.transform.rotate(menu,angle)
                Screen.blit(newmenu,(97-newmenu.get_width()/2,57-newmenu.get_height()/2))
                pygame.display.update()
                angle-=3
            go=True
            item=menu
            while go:
                    self.clock.tick(60)
                    Screen.blit(background,(0,0))
                    Screen.blit(item,(97-newmenu.get_width()/2,57-newmenu.get_height()/2))
                    Screen.blit(self.mouse, pygame.mouse.get_pos())
                    pygame.display.update()
                    # Handle key pressed events
                    events = pygame.event.pump()
                    keys = pygame.key.get_pressed()
                    if keys[pygame.K_ESCAPE]:
                        if func=="start":
                                angle =0
                                newmenu=menu
                                while angle <=90:                
                                    self.clock.tick(60)
                                    Screen.blit(background,(0,0))
                                    newmenu=pygame.transform.rotate(menu,angle)
                                    Screen.blit(newmenu,(97-newmenu.get_width()/2,57-newmenu.get_height()/2))
                                    Screen.blit(self.mouse, pygame.mouse.get_pos())
                                    pygame.display.update()
                                    angle+=3
                                
                                return self.runStartMenu(Screen)
                        if func=="pause":
                                angle =0
                                newmenu=menu
                                while angle <=90:                
                                    self.clock.tick(60)
                                    Screen.blit(background,(0,0))
                                    Screen.blit(rarm,(874-rarm.get_width()/2,470-rarm.get_height()/2))  
                                    newmenu=pygame.transform.rotate(menu,angle)
                                    Screen.blit(newmenu,(97-newmenu.get_width()/2,57-newmenu.get_height()/2))
                                    Screen.blit(self.mouse, pygame.mouse.get_pos())
                                    pygame.display.update()
                                    angle+=3
                                return self.runDirectionsMenu(Screen)
                        go = False
                    mousePos = pygame.mouse.get_pos()
                    mousePressed = pygame.mouse.get_pressed()
                    
                    if mousePos[0]>=410 and mousePos[0] <= 659:
                        if mousePos[1]>=435 and mousePos[1]<=470:
                            item=back
                            if mousePressed[0]:
                                Screen.blit(background,(0,0)) 
                                Screen.blit(item,(97-newmenu.get_width()/2,57-newmenu.get_height()/2))
                                Screen.blit(self.mouse, pygame.mouse.get_pos())
                                pygame.display.update()
                                if func=="start":
                                    angle =0
                                    newmenu=menu
                                    while angle <=90:                
                                        self.clock.tick(60)
                                        Screen.blit(background,(0,0))
                                        newmenu=pygame.transform.rotate(menu,angle)
                                        Screen.blit(newmenu,(97-newmenu.get_width()/2,57-newmenu.get_height()/2))
                                        Screen.blit(self.mouse, pygame.mouse.get_pos())
                                        pygame.display.update()
                                        angle+=3
                                    return self.runStartMenu(Screen)
                                if func=="pause":
                                    angle =0
                                    newmenu=menu
                                    while angle <=90:                
                                        self.clock.tick(60)
                                        Screen.blit(background,(0,0)) 
                                        newmenu=pygame.transform.rotate(menu,angle)
                                        Screen.blit(newmenu,(97-newmenu.get_width()/2,57-newmenu.get_height()/2))
                                        Screen.blit(self.mouse, pygame.mouse.get_pos())
                                        pygame.display.update()
                                        angle+=3
                                    return self.runPauseMenu(Screen)
                                go = False
                        else:
                            item=menu
        
    def runPauseMenu(self, Screen):
            menu=pygame.image.load("data\/pause1.png").convert_alpha()
            background=pygame.image.load("data\/title.png").convert_alpha()
            start=pygame.image.load("data\/pauseStart.png").convert_alpha()
            directions=pygame.image.load("data\/pauseDirections.png").convert_alpha()
            mquit=pygame.image.load("data\/pauseQuit.png").convert_alpha()
            angle =90
            newmenu=menu
            while angle >=0:                
                self.clock.tick(60)
                Screen.blit(background,(0,0))
                newmenu=pygame.transform.rotate(menu,angle)
                Screen.blit(newmenu,(97-newmenu.get_width()/2,57-newmenu.get_height()/2))
                pygame.display.update()
                angle-=3
            go=True
            item=start
            while go:
                    self.clock.tick(60)
                    Screen.blit(background,(0,0))  
                    Screen.blit(item,(97,57))
                    Screen.blit(self.mouse, pygame.mouse.get_pos())
                    pygame.display.update()
                    # Handle key pressed events
                    events = pygame.event.pump()
                    keys = pygame.key.get_pressed()
                    if keys[pygame.K_ESCAPE]:
                        go = False
                    mousePos = pygame.mouse.get_pos()
                    mousePressed = pygame.mouse.get_pressed()
                    
                    if mousePos[0]>=410 and mousePos[0] <= 659:
                        if mousePos[1]>=241 and mousePos[1]<=298:
                            item=start
                            if mousePressed[0]:
                                Screen.blit(background,(0,0)) 
                                Screen.blit(item,(97,57))
                                Screen.blit(self.mouse, pygame.mouse.get_pos())
                                pygame.display.update()
                                return False
                        elif mousePos[1]>=298 and mousePos[1]<=357:
                            item=directions
                            if mousePressed[0]:
                                Screen.blit(background,(0,0))
                                Screen.blit(item,(97,57))
                                Screen.blit(self.mouse, pygame.mouse.get_pos())
                                pygame.display.update()
                                Screen.blit(background,(0,0))  
                                angle =0
                                newmenu=menu
                                while angle <=90:                
                                    self.clock.tick(60)
                                    Screen.blit(background,(0,0))
                                    newmenu=pygame.transform.rotate(menu,angle)
                                    Screen.blit(newmenu,(97-newmenu.get_width()/2,57-newmenu.get_height()/2))
                                    Screen.blit(self.mouse, pygame.mouse.get_pos())
                                    pygame.display.update()
                                    angle+=3
                                return self.runDirectionsMenu(Screen,"pause")
                                
                                 
                        
                        elif mousePos[1]>=357 and mousePos[1]<=414:
                            item=mquit
                            if mousePressed[0]:
                                Screen.blit(background,(0,0))  
                                Screen.blit(item,(97,57))
                                Screen.blit(self.mouse, pygame.mouse.get_pos())
                                pygame.display.update()
                                Screen.blit(background,(0,0))
                                return True


def Outro(Screen):

        font=pygame.font.SysFont("arial",30,True)
        intro=pygame.image.load("intro.png").convert_alpha()
        robot=pygame.image.load("robotfly.png").convert_alpha()
        black=pygame.image.load("black.bmp")
        
        background=pygame.Surface((1024, 768))
        Screen.blit(background,(0,0))
        pygame.display.update()
        height=0
        clock = pygame.time.Clock()
        while height<=368:
            height+=11.5
            
            background.blit(pygame.transform.scale(intro, (1024,height)),(0,768/2-height/2))
            Screen.blit(background,(0,0))
            pygame.display.update()
            
        factor=1.0
        clock = pygame.time.Clock()
        lpos=-500
        
        while factor>=0 :
            factor-=0.004
            lpos+=7
            if lpos>=1024:
                break
            Screen.blit(background,(0,0))
            Screen.blit(pygame.transform.scale(robot, (1000*factor,235*factor)),(lpos,768/2-height/2+150))
            
            pygame.display.update()
        item=0
        

        clock.tick(5)
        fontsurface=font.render("And with that, Our hero flies off to once again...",True,(255,255,255))
        Screen.blit(fontsurface,(1024/2-fontsurface.get_width()/2,768/2-fontsurface.get_height()/2+250))
        pygame.display.update()
        clock.tick(0.4)
        
        Screen.blit(background,(0,0))
        fontsurface=font.render("Battle with Global warming!!!!!!",True,(255,255,255))
        Screen.blit(fontsurface,(1024/2-fontsurface.get_width()/2,768/2-fontsurface.get_height()/2+250))
        pygame.display.update()
        loops=0
        clock.tick(1)
        while loops<=255:
            loops+=5
            black.set_alpha(loops)
            Screen.blit(black,(0,0))
            pygame.display.update()
        go=True
        while go:
                    # Handle key pressed events
                    events = pygame.event.pump()
                    keys = pygame.key.get_pressed()
                    if keys[pygame.K_ESCAPE]:
                        go = False
def Intro(Screen):

        font=pygame.font.SysFont("arial",30,True)
        intro=pygame.image.load("data\/intro.png").convert_alpha()
        robot=pygame.image.load("data\/robotintro.png").convert_alpha()
        robot2=pygame.image.load("data\/robotburn.png").convert_alpha()
        uv=pygame.image.load("data\/lightning.png").convert_alpha()
        water=pygame.image.load("data\/water.png").convert_alpha()
        black=pygame.image.load("data\/black.bmp")
        
        robothead=pygame.image.load("data\/robothead.png").convert_alpha()
        background=pygame.Surface((1024, 768))
        Screen.blit(background,(0,0))
        pygame.display.update()
        height=0
        clock = pygame.time.Clock()
        while height<=368:
            height+=11.5
            background.blit(pygame.transform.scale(intro, (1024,height)),(0,768/2-height/2))
            Screen.blit(background,(0,0))
            pygame.display.update()
            
        
        item=0
        

        clock.tick(5)
        fontsurface=font.render("In the year 2008",True,(255,255,255))
        Screen.blit(fontsurface,(1024/2-fontsurface.get_width()/2,768/2-fontsurface.get_height()/2+250))
        pygame.display.update()
        clock.tick(0.4)
        Screen.blit(background,(0,0))
        fontsurface=font.render("A Lone Robot stood to take on an evil unlike the world had ever seen.",True,(255,255,255))
        Screen.blit(fontsurface,(1024/2-fontsurface.get_width()/2,768/2-fontsurface.get_height()/2+250))
        pygame.display.update()
        
        rpos=-252
        while rpos<=10:
            rpos +=2
            clock.tick(50)
            Screen.blit(background,(0,0))
        
            Screen.blit(robot,(rpos,768/2+378/2-375))
            Screen.blit(fontsurface,(1024/2-fontsurface.get_width()/2,768/2-fontsurface.get_height()/2+250))
            pygame.display.update()

        fontsurface=font.render("Global Warming!",True,(255,255,255))
        Screen.blit(background,(0,0))
        Screen.blit(robot,(rpos,768/2+378/2-375))
        Screen.blit(fontsurface,(1024/2-fontsurface.get_width()/2,768/2-fontsurface.get_height()/2+250))
        pygame.display.update()
        clock.tick(0.4)
        fontsurface=font.render("And with a mighty UV ray followed by a hydrostrike,",True,(255,255,255))
        Screen.blit(background,(0,0))
        Screen.blit(robot,(rpos,768/2+378/2-375))
        Screen.blit(fontsurface,(1024/2-fontsurface.get_width()/2,768/2-fontsurface.get_height()/2+250))
        pygame.display.update()
        lpos=1024
        
        while lpos>-375:
            clock.tick(60)
            Screen.blit(background,(0,0))
            if lpos<=200:
                robot=robot2
            Screen.blit(robot,(rpos,768/2+378/2-375))
            Screen.blit(fontsurface,(1024/2-fontsurface.get_width()/2,768/2-fontsurface.get_height()/2+250))
            Screen.blit(uv,(lpos,768/2+378/2-375))
            lpos-=20
            pygame.display.update()
        lpos=1024
        while lpos>-375:
            clock.tick(60)
            Screen.blit(water,(lpos,768/2+378/2-375))
            lpos-=20
            pygame.display.update()
        clock.tick(0.4)
        fontsurface=font.render("Our hero robot was almost destroyed!",True,(255,255,255))
        Screen.blit(background,(0,0))
        
        Screen.blit(fontsurface,(1024/2-fontsurface.get_width()/2,768/2-fontsurface.get_height()/2+250))
        pygame.display.update()
        
        
        angle=0
        lpos=-50
        while lpos<=100:
            clock.tick(60)
            lpos+=2
            angle-=2
            Screen.blit(background,(0,0))
            Screen.blit(fontsurface,(1024/2-fontsurface.get_width()/2,768/2-fontsurface.get_height()/2+250))
            Screen.blit(pygame.transform.rotate(robothead, angle),(lpos,768/2+378/2-375+150))
            pygame.display.update()
        clock.tick(0.4)
        background.blit(pygame.transform.rotate(robothead,angle),(lpos,768/2+378/2-375+150))
        fontsurface=font.render("It is your responsibility to help rebuild our trusty robot",True,(255,255,255))
        Screen.blit(background,(0,0))
        
        Screen.blit(fontsurface,(1024/2-fontsurface.get_width()/2,768/2-fontsurface.get_height()/2+250))
        pygame.display.update()
        clock.tick(0.4)
        loops=0
        while loops<=255:
            loops+=5
            black.set_alpha(loops)
            Screen.blit(black,(0,0))
            pygame.display.update()
            
class Main:
    def __init__(self, size, title):
        self.screen = pygame.display.set_mode((size[0], size[1]), pygame.FULLSCREEN)
        pygame.display.set_caption(title)
        self.grid = Grid(720,720)
        self.partsMenu = PartsMenu()
        self.blitSelected = False
        self.mousePart = Part(self.partsMenu.partsList[self.partsMenu.partSelected].type)
        self.mouseUp = True
        self.mouseUp2 = True
        self.mouseSound = pygame.mixer.Sound("data\/s1.wav")
        self.mouse = pygame.image.load("data\/mouse.png").convert_alpha()
        self.timer = 150
        self.font = pygame.font.SysFont("Arial", 30)
        self.score = 0
        self.allScore = 0
        self.clock = pygame.time.Clock()
        self.mainMenu = MainMenu()
        self.GUIOverlay = pygame.image.load("data\/GUI.png").convert_alpha()
    

    def MouseCheck(self, button1, button2):
        self.grid.gridSelection = -1
        mousePos = pygame.mouse.get_pos()
        mousePressed = pygame.mouse.get_pressed()
        if(mousePressed[0] == False):
            self.mouseUp = True
        if(mousePressed[2] == False):
            self.mouseUp2 = True
        count = 0
        self.blitSelected = False
        if(mousePos[0] >= self.grid.gridPos[0] and mousePos[0] < self.grid.gridPos[0] + self.grid.width):
            if(mousePos[1] >= self.grid.gridPos[1] and mousePos[1] < self.grid.gridPos[1] + self.grid.height):
                for pos in self.grid.list:
                    if mousePos[0] >= self.grid.gridPos[0] + pos[0] and mousePos[0] < self.grid.gridPos[0] + pos[0] + self.grid.squareSize:
                        if mousePos[1] >= self.grid.gridPos[1] + pos[1] and mousePos[1] < self.grid.gridPos[1] + pos[1] + self.grid.squareSize:
                            break
                    count += 1

                self.grid.gridSelection = count
                if(mousePressed[0] == True and self.mouseUp == True):
                    if(self.grid.partsList[self.grid.gridSelection]):
                        if(self.grid.partsList[self.grid.gridSelection].user == True):
                            self.mouseSound.play()
                            self.grid.partsList[self.grid.gridSelection] = self.mousePart
                            self.mousePart = Part(self.partsMenu.partsList[self.partsMenu.partSelected].type)
                            self.mouseUp = False
                    else:
                        self.mouseSound.play()
                        self.grid.partsList[self.grid.gridSelection] = self.mousePart
                        self.mousePart = Part(self.partsMenu.partsList[self.partsMenu.partSelected].type)
                        self.mouseUp = False
                elif(mousePressed[2] == True and (button1 == True or button2 == True)):
                    if(self.grid.partsList[self.grid.gridSelection]):
                        if(self.grid.partsList[self.grid.gridSelection].user == True):
                            done = False
                            for part in self.grid.currentList:
                                if(self.grid.gridSelection == part):
                                    self.grid.currentList.remove(part)
                                    done = True
                                elif(done == True):
                                    self.grid.currentList.remove(part)                                    
                            self.grid.partsList[self.grid.gridSelection] = None
                            self.mouseSound.play()
                elif(mousePressed[2] == True and self.mouseUp2 == True and (button1 == False and button2 == False)):
                    self.mousePart.Rotate("left")
                    self.mouseUp2 = False
                            
                    
        elif(mousePos[0] >= self.partsMenu.partsPos[0]):
            if(mousePos[1] >= self.partsMenu.partsPos[1]):
                if(mousePressed[0] == True):
                    k = 0
                    for pos in self.partsMenu.partsListPos:
                        if(mousePos[0] >= pos[0] and \
                           mousePos[0] < pos[0] + 60):
                            if(mousePos[1] >= pos[1] and \
                               mousePos[1] < pos[1] + 60):
                                self.partsMenu.partSelected = k
                                self.mousePart = Part(self.partsMenu.partsList[self.partsMenu.partSelected].type)
                        k += 1
                              
    def Render(self):
        # Clear the screen
        pygame.draw.rect(self.screen, (0,0,0), (0, 0, self.screen.get_width(), self.screen.get_height()))

        # Render everything else
        self.grid.Render(self.screen)

        if self.grid.gridSelection >= 0:
            self.screen.blit(self.mousePart.image, (self.grid.list[self.grid.gridSelection][0] + self.grid.gridPos[0],\
                                                      self.grid.list[self.grid.gridSelection][1] + self.grid.gridPos[1]))

        self.screen.blit(self.GUIOverlay, (0,0))
        self.partsMenu.Render(self.screen)
        self.screen.blit(self.font.render("Score", True, (255,255,255)), (35, 250))
        self.screen.blit(self.font.render(str(self.allScore), True, (255,255,255)), (35, 285))
        self.screen.blit(self.font.render("Time Left", True, (255,255,255)), (11, 430))
        self.screen.blit(self.font.render(str(self.timer), True, (255,255,255)), (47, 465))
        self.screen.blit(self.font.render("Voltage", True, (240,240,0)), (900, 15))
        self.screen.blit(self.font.render("Needed", True, (240,240,0)), (900, 50))
        self.screen.blit(self.font.render(str(self.grid.voltageNeeded), True, (240,240,0)), (930, 85))
        
        mousePos = pygame.mouse.get_pos()
        self.screen.blit(self.mouse, (mousePos[0], mousePos[1]))

        # Update to the screen
        pygame.display.update()
        
    def Run(self):
        pygame.mouse.set_visible(False)
        Intro(self.screen)
        gameQuit = self.mainMenu.runStartMenu(self.screen)
        rdown = False
        ldown = False
        edown = False
        levelComplete = False
        timeCount = 0
        levelSplash = []
        i = 1
        while(i <= 15):
            levelSplash.append(pygame.image.load("data\/splash" + str(i) + ".png"))
            i += 1
        level = 1
        endLevel = None
        while(not gameQuit):
            if(endLevel == "win"):
                level += 1
                if(self.score >= 1500):
                    score = bonus.game(self.screen)
                    if(score == "done"):
                        levelComplete = gameQuit = True
                    elif(score):
                        self.allScore += score
                        
            self.timer = 150
            timeCount = 0
            self.score = 0
            endLevel = None
            levelComplete = False
            pygame.mixer.music.load("data\/" + str(random.randint(0,6)) + ".mid")
            pygame.mixer.music.play(-1)
            if(level <= 15):
                self.screen.blit(levelSplash[level - 1], (0,0))
                pygame.display.update()
                time.sleep(7)
                self.grid.LoadLevel(level, (5 * random.randint(1,20),10 * random.randint(1,20)),  self.partsMenu.partsList)
            else:
                Outro(self.screen)
                Credits(self.screen)
                levelComplete = gameQuit = True
            while(not levelComplete):
                self.clock.tick(60)
                timeCount += 1
                if(timeCount == 60):
                    self.timer -= 1
                    timeCount = 0
                # Handle key pressed events
                events = pygame.event.pump()
                keys = pygame.key.get_pressed()
                if keys[pygame.K_ESCAPE] and edown == False:
                    doquit = self.mainMenu.runPauseMenu(self.screen)
                    if(doquit == True):
                        levelComplete = gameQuit = True
                    edown = True
                elif keys[pygame.K_LCTRL] and ldown == False:
                    ldown = True
                elif keys[pygame.K_RCTRL] and rdown == False:
                    rdown = True
                if (not keys[pygame.K_LCTRL]):
                    ldown = False
                if (not keys[pygame.K_RCTRL]):
                    rdown = False
                if (not keys[pygame.K_ESCAPE]):
                    edown = False
                
                self.MouseCheck(ldown, rdown)
                endLevel = self.grid.CheckPower()
                
                if(endLevel == "win"):
                    for p in self.grid.currentList:
                        self.score += 100
                    self.allScore += self.score
                    levelComplete = True
                elif(endLevel == "blow"):
                    for p in self.grid.currentList:
                        self.score -= 50
                    self.allScore += self.score
                    levelComplete = True
                self.Render()
                
def Credits(Screen):
    mcredits=pygame.image.load("credits.png").convert_alpha()
    black=pygame.image.load("black.bmp")
    lpos=768
    clock = pygame.time.Clock()
    while lpos>=-2500:
        clock.tick(30)
        lpos-=5
        Screen.blit(black,(0,0))
        Screen.blit(mcredits,(0,lpos))   
        pygame.display.update()
       
def main():        
    pygame.init()
    pygame.display.init()
    pygame.mixer.init()
    pygame.font.init()

    main = Main((1024,768), "Sparky: Never Gonna Give Up")
    main.Run()
        
    pygame.quit()

if __name__ == "__main__":
    main()
